var chrome = chrome || browser;

var busy = false;
var DEBUG = false;

function debug(message, jsonobj){
	if (DEBUG){
		console.log("Background - " + message + (jsonobj ? JSON.stringify(jsonobj) : ""));
	}
}

debug("loaded");

chrome.tabs.onRemoved.addListener( (tabId, removeInfo) => {
	debug(`Tab: ${tabId} is closing`);
	
	let req2bisc = {
		method: "tabClosed", 
		biscTabId: tabId.toString().padStart(10, '0')
	};
	
 	chrome.runtime.sendNativeMessage("bisc", req2bisc, response => {
		if (response) {
			debug("received response from native app: ", response);
		} else {
			if (chrome.runtime.lastError){
				console.log(`Background WARN - ${chrome.runtime.lastError.message}`);
			}
		}
	});
});

chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
	DEBUG = request.tracing;
	debug("received message from content script, sending to native app...");
	if (busy) {
		sendResponse({error_code: -11});
		return true;
	}
	busy = true;
	request.message.biscTabId = sender.tab.id.toString().padStart(10, '0');
	chrome.runtime.sendNativeMessage("bisc", request.message, response => {
		busy = false;
		if (response) {
			debug("received response from native app: ", response);
			sendResponse(response);
		} else {
			if(chrome.runtime.lastError) {
				console.log(`Background WARN - ${chrome.runtime.lastError.message}`);
			}
		}
	});
	return true;
});